import java.util.Vector;
import java.util.StringTokenizer;


// Lrp Network Monitor: Simple network monitor written in Java
// Copyright (C) 2000 Martin Hejl
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


/**
 * Class that parses the output of cat /proc/net/dev
 * and soon also cat /dev/isdninfo
 *
 * @author       Martin Hejl
 * @version      20001105 0.1beta
 */
public class InterfaceInfoParser {

	Vector interfaces;

	public void parseProcNetDev(String s) {
		interfaces = new Vector();
		InterfaceInfo ifInformation;

		// Skip the first two lines
		StringTokenizer st = new StringTokenizer(s, "\n");
		String str="";
		String ss;
		ss = st.nextToken();
		ss = st.nextToken();
		while (st.hasMoreTokens()) {
			ss = st.nextToken();
			str=str + ss + " ";

		}

		st = new StringTokenizer(str,": ");
        while (st.hasMoreTokens()) {
			ifInformation = new InterfaceInfo();

			if (st.hasMoreTokens())	ifInformation.setName(st.nextToken());
			if (st.hasMoreTokens())	ifInformation.setBytes(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setPackets(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setErrors(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setDrop(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setFifo(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setFrame(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setCompressed(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setMulticast(atol(st.nextToken()),InterfaceInfo.DIRECTION_RECEIVE );
			if (st.hasMoreTokens())	ifInformation.setBytes(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);
			if (st.hasMoreTokens())	ifInformation.setPackets(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);
			if (st.hasMoreTokens())	ifInformation.setErrors(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);
			if (st.hasMoreTokens())	ifInformation.setDrop(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);
			if (st.hasMoreTokens())	ifInformation.setFifo(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);
			if (st.hasMoreTokens())	ifInformation.setColls(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);
			if (st.hasMoreTokens())	ifInformation.setCarrier(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);
			if (st.hasMoreTokens())	ifInformation.setCompressed(atol(st.nextToken()),InterfaceInfo.DIRECTION_TRANSMIT);

			interfaces.addElement((Object)ifInformation);
          }
	}

	public void parseIsdnInfo(String s) {
	}

	public Vector getInfo(){
		return(interfaces);
	}


	private long atol(String s) {
		try {
			return(Long.valueOf(s).longValue());
		} catch (NumberFormatException ex) {
			return (-1);
		}
	}
}

